
package com.a06.model;

import java.lang.Object.*;
import java.util.StringTokenizer.*;
import java.util.*;
import java.lang.String.*;


/**
    Stores pre-formatted user schedules in order to support persistence.
    @author LaToya White
    @version 1.1 (March 19, 2006)
*/ 
public class StoreData
{
  private static ArrayList<String> finalList= new ArrayList<String>();
  private static final int MAXUSERS = 20;
  private static StringBuffer SBnames = new StringBuffer(); 

   /**
       @param userList an ArrayList of preformatted Strings containing the availability of each user
   */
   public StoreData(ArrayList<String> userList){
    finalList = userList;
   }

   /**
       @return The names of each user for each schedule 
   */
   public static String getSBnames(){
     return SBnames.toString();
   }  

   /**
       @return TRUE if no user schedules are stored, FALSE otherwise
   */
   public static boolean isEmpty() {
     boolean x = finalList.isEmpty();
   return (x); 
   } 

   /**
       @return The number of user schedules stored
   */
   public static int size() {
     return(finalList.size());
   }

   /**
       @param newstring a pre-formatted String to be stored
   */
   public static void add(String newstring) {
    finalList.add(newstring);
   }

   /**
       Clears all of the stored data
   */
   public static void clear() {
    finalList.clear();
    SBnames.setLength(0);
   }

   /**
       @param i the index of the user to be returned
       @return The String corresponding to the supplied index
   */
   public static String get (int i) {
    return finalList.get(i);
   } 

   /**
       @return A String array of schedules for all users
   */
   public static String [] getList () {
    String [] tempList = new String [MAXUSERS];
    for (int i= 0; i < StoreData.size(); i++) {
      tempList[i] = StoreData.get(i);
     }
    return (tempList);
   }

   /**
       @return A String array of busy times for all users
   */
   public static ArrayList<String> getBusy() {
    //get just the busy and free times to feed the funnel
    //append the usernames to a stringbuffer //jm
      SBnames.setLength(0); // reset   = "";
      ArrayList<String> justBusy = new ArrayList<String>();
      int nValues= StoreData.size();
      if (nValues == 0) {
    return justBusy; 
   }  // do a loop thru the finalList stuff !!!!!!!!!!!!!!!!
    for (int i = 0; i< StoreData.size(); i++ ) {
       String [] arr = StoreData.get(i).split(":",2); // get everything after name
     SBnames.append(arr[0] + ',' );
     justBusy.add(arr[1]);
     }
    return justBusy;
    }

   /**
       Stores a new user schedule, or replaces the existing user schedule if applicable.
       @param newSched a preformatted String containing the new user schedule
       @return An ArrayList of Strings containing schedules for all users, including the new addition
   */
   public static ArrayList<String> ProcessData(String newSched){
    StringTokenizer newST= new StringTokenizer(newSched, ":");
    String newString = newST.nextToken();
    
      if(StoreData.size() == 0) { // just add if is empty
        finalList.add(newSched);
      }
    
         for(int i=0; i<StoreData.size(); i++) {
          //Breaking the string apart at the first occurence of a colon to ob tain
          //the username for later comparisons.
          String oldVal = finalList.get(i);
          StringTokenizer oldST = new StringTokenizer(oldVal,":");
          String old = oldST.nextToken();

          System.out.println( newString + "  " + old +" "+ i);

          //testing the first characters to determine if
          //the user already has a schedule listed. If so replace it
          //otherwise go through the loop and try the next string in the list
          if( old.equals(newString)){          // if name exists already, replace 
            finalList.set(i, newSched);
           return finalList;
          }
        } // end for each item

    finalList.add(newSched); // not exists anyplace, so add
    return finalList;  //when the loop is done, the input string(schedule) has been added

}
}
