package com.a06.model;

import java.io.*;
import java.util.*;
import java.lang.String.*;

/**
    Final version of View component; accepts HTML form data, communicates with Parser and Controller, and stores summarized calendar data in persistant variable.
    @author CISC474 Group 10
    @version 1.9 (April 2, 2006)
*/
public class WebView {

  public static String [] HTML = new String [5]; // 5 day work week
  private static String funneledData;
  public static String [] binaryVersion = new String[5]; // e.g. '111000011000'

  /**
      @param Mon a String representing busy times for Monday
      @param Tue a String representing busy times for Tuesday
      @param Wed a String representing busy times for Wednesday
      @param Thu a String representing busy times for Thursday
      @param Fri a String representing busy times for Friday
      @param username a String containing the user's identifier
      @param clear if equal to "on", all stored data will be cleared
      @return Always returns 1, since JSP must have something returned
  */  
  public static int  WebView (String Mon, String Tue, String Wed,
        String Thu, String Fri, String username, String clear) {

  final int MAXUSERS = 20; // totally arbitary
  final int NPERIODS = 16; // N half hour periods in 8 hr business day
  
  if (clear.equals("on")) {
     StoreData.clear();
  }
  // now process data using StoreData method, store results there
  // for persistance in static variable declared in StoreData
  //Mon:9:00-11:00,2:30-4:30;Tue:;Wed:;Thu:;Fri:;
  String newEntry= username + ":" +
    "M:"+ Parser.doParse(Mon) + ";" +
    "T:"+ Parser.doParse(Tue) + ";" +
    "W:"+ Parser.doParse(Wed) + ";" +
    "T:"+ Parser.doParse(Thu) + ";" +
    "F:"+ Parser.doParse(Fri) + ";" ;


   ArrayList<String> localList = new ArrayList<String>();
   localList= StoreData.ProcessData(newEntry);

   // create a ListArray of just times (no names) for funneling= summarizing
   ArrayList<String> combined = new ArrayList<String>();
   combined = StoreData.getBusy();
   Controller a06 = new Controller(StoreData.getBusy());
   funneledData= a06.funnelData();

   //now convert the summarized times into HTML <td>xxx</td>
   String dayHTML[] = new String[MAXUSERS];
   dayHTML = funneledData.split(";"); //M:1,0,1,0 etc
   for (int i= 0; i< 5; i++) { // 5 days/week
     StringBuffer htmlSB = new StringBuffer();
     String oneDay[]=new String[2];
     oneDay = dayHTML[i].split(":");    // M:  vs 0,1,0 etc
     //HTML[] static in StoreData
     HTML[i] = oneDay[1].replace("," , ""); // now 1110000111
     binaryVersion[i]=HTML[i]; 
     for (int j =0; j<16; j++) {
       String nextChar = String.valueOf(HTML[i].charAt(j));
       if (nextChar.equals("1")) {
          htmlSB.append("<td bgcolor='red'>" +  "</td>");   
        }else {  
        htmlSB.append("<td bgcolor='blue'>" +  "</td>");   
       }
      } // end for loop for one day
    HTML[i]=htmlSB.toString();
    } // end for each day
   return 1;  // calls must return something in jsp's
  } // end method	
} // end class


